/*
    PLDI Windows	0.0.3
    Piotr Grochowski <pager@dione.ids.pl>    
*/

#include <newt.h>
#include "newt-addon.h"
#include <stdlib.h>
#include <stdlib.h>
#include <string.h>
#include "defines.h"

/*  Show a window with entry field, optionasl label, and two buttons */
/*  you can set entry width with ent_width variable */
/*  return entry value or NULL */
char *winEntryDialogTwoCompactBtn(char *title, char *label, int ent_width,
                           char *value, int flags)
{
    newtComponent frm, lbl, ent, btnOK, btnAbort, returnComp;
    newtGrid grid, buttons, entries;
    char result[255];

    frm = newtForm(NULL, NULL, 0);
    lbl = newtLabel(-1, -1, label);
    ent = newtEntry(-1, -1, value, ent_width, NULL, flags
                    | NEWT_FLAG_RETURNEXIT);

    buttons = newtCompactButtonBar(_("Ok"), &btnOK,
                                   _("Abort"), &btnAbort,
                                   NULL);
    grid = newtCreateGrid(1, 2);
    entries = newtCreateGrid(2, 1);
    newtGridSetField(entries, 0, 0, NEWT_GRID_COMPONENT, lbl,
                     0, 0, 0, 0, NEWT_ANCHOR_LEFT, 0);
    newtGridSetField(entries, 1, 0, NEWT_GRID_COMPONENT, ent,
                     0, 0, 0, 0, NEWT_ANCHOR_LEFT, 0);
    newtGridSetField(grid, 0, 0, NEWT_GRID_SUBGRID, entries,
                     0, 0, 0, 1, 0, 0);
    newtGridSetField(grid, 0, 1, NEWT_GRID_SUBGRID, buttons,
                     0, 0, 0, 0, 0, 0);
    newtGridWrappedWindow(grid, title);
    newtGridAddComponentsToForm(grid, frm, 1);

    newtGridFree(grid, 1);

    newtFormAddHotKey(frm, 27);
    returnComp = newtRunForm(frm);

    if ((returnComp == ent) || (returnComp == btnOK)) {
        strcpy(result, newtEntryGetValue(ent));
    } else
        strcpy(result, "");

    newtFormDestroy(frm);
    newtPopWindow();
    if (!strcmp(result, ""))
        return NULL;
    return strdup(result);
}


char * winEntryDialogOneBtn(char * title, char * label, int ent_width, 
			    char * value, int flags)
{
    newtComponent frm,lbl,ent,btnOK;
    char result[255];
    int width=strlen(label)+ent_width+3;

    newtOpenWindow((80-width)/2,10,width,7,title);
    frm=newtForm(NULL,NULL,0);
    lbl=newtLabel(1,1,label);
    ent=newtEntry(strlen(label)+2,1,value,ent_width,NULL,flags 
						| NEWT_FLAG_RETURNEXIT);
    btnOK=newtButton(width/2-3,3,_("Ok"));
    newtFormAddComponents(frm,lbl,ent,btnOK,NULL);
    newtRunForm(frm);

    strcpy(result,newtEntryGetValue(ent));

    newtFormDestroy(frm);
    newtPopWindow();

    return strdup(result);
}

char * winEntryDialogTwoBtn(char * title, char * label, int ent_width, 
			char * value,int flags)
{
    newtComponent frm,lbl,ent,btnOK,btnAbort,returnComp;
    char result[255];
    int width=strlen(label)+ent_width+3;

    newtOpenWindow((80-width)/2,10,width,7,title);
    frm=newtForm(NULL,NULL,0);
    lbl=newtLabel(1,1,label);
    ent=newtEntry(strlen(label)+2,1,value,ent_width,NULL,flags 
						| NEWT_FLAG_RETURNEXIT);
    btnOK=newtButton(width/4-3,3,_("Ok"));
    btnAbort=newtButton(3*(width/4)-4,3,_("Abort"));
    newtFormAddComponents(frm,lbl,ent,btnOK,btnAbort,NULL);
    returnComp=newtRunForm(frm);

    if((returnComp==ent) || (returnComp==btnOK))
    {
        strcpy(result,newtEntryGetValue(ent));
    }
    else strcpy(result,"");

    newtFormDestroy(frm);
    newtPopWindow();

    return strdup(result);
}

newtComponent frmScale,sclScale;

int winScale(char * title,int width, long long full_value)
{
    newtOpenWindow((80-width-2)/2,10,width+2,3,title);
    frmScale=newtForm(NULL,NULL,0);
    sclScale=newtScale(1,1,width,full_value);
    newtFormAddComponent(frmScale,sclScale);
    newtDrawForm(frmScale);
    newtRefresh();
    return 1;
}

int winScaleUpdate(long long value)
{
    newtScaleSet(sclScale,value);
    newtDrawForm(frmScale);
    newtRefresh();
    return 1;
}

int winScaleDestroy()
{
    newtFormDestroy(frmScale);
    newtPopWindow();
    return 1;
}
