#ifndef __UTILS_H
#define __UTILS_H

#include <trurl/narray.h>

#include "log.h"
#include "defines.h"

#undef streq
#undef strne
#define streq(a, b) (strcmp(a, b) == 0)
#define strne(a, b) (strcmp(a, b) != 0)


/*
  RET: bool
*/
int is_dir(const char *path);

#define is_not_dir(a) (is_dir(a) == 0)

/*
  rename file to name.orig
  RET: bool
*/
int backup_file(const char *pathname);


/*
  builds path with its arguments
  
  NOTE:
  Returned pointer points to a static area of memory
  which is overwritten by subsequent calls to buildpath()
  
 */
char *buildpath(const char *dir, ...);

/*
  make directory if it not exists
  RET: bool
*/
 
int mkdir_ifnone(const char *path);

/*
  makes a directory hierarchy, skips existings dirs 
  RET: bool
*/
int mkdirhier(const char *path);


int find(tn_array **flist, const char *path, const char *pattern);

#ifndef basename
#define basename(a) pldi_basename(a)
#endif

const char *pldi_basename(const char *path);

char *machine_type(char *mtype);

#endif
